#/bin/bash
PATH=/var/log/copfilter/default/opt/sqlite/default/bin:/sbin:/usr/sbin:/usr/local/sbin:/bin:/usr/bin:/usr/local/bin
. /var/log/copfilter/default/etc/global_settings
TEMPDIR=/tmp/clamdatabases
declare -i UPDATES=0
chmod 0644 $TEMPDIR/*
chown clamav.clamav $TEMPDIR/*
LOGFILE=$1
FILES=`ls $TEMPDIR`

for FILE in $FILES; do
	if [ -f $BASEDIR/opt/clamav/virdb/$FILE ]; then
		MD5_TMPDB=`md5sum $TEMPDIR/$FILE | awk '{print $1}'`
		MD5_DB=`md5sum $BASEDIR/opt/clamav/virdb/$FILE | awk '{print $1}'`
		if [ $MD5_TMPDB != $MD5_DB ]; then
			$BASEDIR/opt/clamav/default/bin/clamscan --quiet --database=$TEMPDIR/$FILE &>/dev/null
			FEHLER=$?
			if [ $FEHLER == 0 ];then
				rsync -az $TEMPDIR/$FILE $BASEDIR/opt/clamav/virdb/$FILE
				ERG=$?
				if [ ! $ERG == 0 ]; then
					echo "database $FILE copy failed..." >>$LOGFILE
					echo "check your databases!" >>$LOGFILE
				else
					UPDATES=UPDATES+1
				fi
			else
				echo "database $FILE is corrupted! deleting..." >>$LOGFILE
				rm -f $TEMPDIR/$FILE
			fi
		fi
	else
			$BASEDIR/opt/clamav/default/bin/clamscan --quiet --database=$TEMPDIR/$FILE &>/dev/null
			FEHLER=$?
			if [ $FEHLER == 0 ];then
				rsync -az $TEMPDIR/$FILE $BASEDIR/opt/clamav/virdb/$FILE
				ERG=$?
				if [ ! $ERG == 0 ]; then
					echo "database $FILE copy failed..." >>$LOGFILE
					echo "check your databases!" >>$LOGFILE
				else
					UPDATES=UPDATES+1
				fi
			else
				echo "database $FILE is corrupted! deleting..." >>$LOGFILE
				rm -f $TEMPDIR/$FILE
			fi
	fi

done
exit $UPDATES