#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#



use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';


$copfiltersettings{'ACTION'} = '';
$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
&Header::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_mail.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}



######### SMTP_AUTH_ENABLE
$selected{'SMTP_AUTH_ENABLE'}{'off'} = '';
$selected{'SMTP_AUTH_ENABLE'}{'on'} = '';
$selected{'SMTP_AUTH_ENABLE'}{$copfiltersettings{'SMTP_AUTH_ENABLE'}} = "selected='selected'";

######### UPDATE_MAILS
$selected{'UPDATE_MAIL_NOTIF'}{'off'} = '';
$selected{'UPDATE_MAIL_NOTIF'}{'on'} = '';
$selected{'UPDATE_MAIL_NOTIF'}{$copfiltersettings{'UPDATE_MAIL_NOTIF'}} = "selected='selected'";

######### SMTP_AUTH_SECURE
$selected{'SMTP_AUTH_SECURE'}{'off'} = '';
$selected{'SMTP_AUTH_SECURE'}{'sslv3'} = '';
$selected{'SMTP_AUTH_SECURE'}{'tlsv1'} = '';
$selected{'SMTP_AUTH_SECURE'}{$copfiltersettings{'SMTP_AUTH_SECURE'}} = "selected='selected'";



################################################################################
##   ACTIONs
################################################################################


######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save_norestart'})
{ 

################################################################################
##   Checking input values
################################################################################

	if ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_SECURE'} !~ /^(off|sslv3|tlsv1)$/ || 
	    $copfiltersettings{'UPDATE_MAIL_NOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

        if ( $copfiltersettings{'EMAIL_ADR'} eq '' )
        {
                $errormessage = $Lang::tr{'copfilter missing email address'};
                goto ERROR;
        }
       
        if ( !&General::validemail($copfiltersettings{'EMAIL_ADR'}) )
        {
                $errormessage = $Lang::tr{'copfilter invalid email address'};
                goto ERROR;
        }

        if ( $copfiltersettings{'SENDER_ADR'} eq '' ) {

                $copfiltersettings{'SENDER_ADR'} = $copfiltersettings{'EMAIL_ADR'}
        }
        else {
                if ( !&General::validemail($copfiltersettings{'SENDER_ADR'}) ) {
                $errormessage = $Lang::tr{'copfilter invalid sender email address'};
                goto ERROR;
                }
        }

        if ($copfiltersettings{'SMTP_HOST'} =~ /^$/)
        {
                $errormessage = $Lang::tr{'copfilter missing smtp host'};
                goto ERROR;
        }


# deactivated because ipcop validfqdn routine does not allow numbers after the dot in the fqdn 20070328
#        if ( ($copfiltersettings{'SMTP_HOST'} !~ /:/) )
#        {
#            if ( !(&General::validip($copfiltersettings{'SMTP_HOST'}) || &General::validfqdn($copfiltersettings{'SMTP_HOST'}) ) ){
#                            $errormessage = $Lang::tr{'copfilter invalid smtp host'};
#                            goto ERROR;  
#            }
#        }


        if ( $copfiltersettings{'SMTP_AUTH_ENABLE'} eq 'on' && $copfiltersettings{'SMTP_AUTH_USER'} eq '' )
        {
                $errormessage = $Lang::tr{'copfilter missing smtp auth user'};
                goto ERROR;
        }

        if ( $copfiltersettings{'SMTP_AUTH_ENABLE'} eq 'on' && $copfiltersettings{'SMTP_AUTH_PASS'} eq '' )
        {
                $errormessage = $Lang::tr{'copfilter missing smtp auth password'};
                goto ERROR;
        }

 

ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{


           unlink "${copfilter_swroot}/etc/smtp_auth_enable";

           if ($copfiltersettings{'SMTP_AUTH_ENABLE'} eq 'on') {
            system ('touch', "${copfilter_swroot}/etc/smtp_auth_enable"); }


# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);


        }


$copfiltersettings{'ACTION'} = '';

}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "&nbsp;</class>\n";
    &Header::closebox();
}


################################################################################
##  Website - Email Settings
################################################################################
print "<a name='email'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter email'}:");
print "<form method='post' action='/cgi-bin/copfilter_mail.cgi' enctype='multipart/form-data'>";
print <<END

<table width='100%' border='0'>

<tr>
        <td width='17%'></td>
        <td width='30%'></td>
        <td width='2%'></td>
        <td width='23%'></td>
        <td width='28%'></td>
</tr>

<tr>
        <td>$Lang::tr{'copfilter email address'}:&nbsp; </td>
        <td><input type='text' size="25" name='EMAIL_ADR' value='$copfiltersettings{'EMAIL_ADR'}' /> </td>
        <td> </td>
        <td>SMTP-AUTH $Lang::tr{'copfilter enabled'}:&nbsp; </td>
        <td> <select name='SMTP_AUTH_ENABLE'>
             <option value='on' $selected{'SMTP_AUTH_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_AUTH_ENABLE'}{'off'}>off</option> </select></td>

</tr>

<tr>
        <td>$Lang::tr{'copfilter smtp host'}:*&nbsp; </td>
        <td><input type='text' size="25" name='SMTP_HOST' value='$copfiltersettings{'SMTP_HOST'}' /> </td>
        <td> </td>
        <td>$Lang::tr{'copfilter smtp auth user'}:&nbsp;<img src='/blob.gif' alt='*' /> </td>
        <td> <input type='text' size="15" name='SMTP_AUTH_USER' value='$copfiltersettings{'SMTP_AUTH_USER'}' /></td>
</tr>

<!-- <tr>
        <td> $Lang::tr{'copfilter smtp port'}:&nbsp; </td>
        <td> <input type='text' size="25" name='SMTP_PORT' value='$copfiltersettings{'SMTP_PORT'}' /></td>
        <td> </td>
</tr>-->

<tr>
        <td> $Lang::tr{'copfilter sender address'}:&nbsp;<img src='/blob.gif' alt='*' /></td>
        <td> <input type='text' size="25" name='SENDER_ADR' value='$copfiltersettings{'SENDER_ADR'}' /></td>
        <td> </td>
        <td>$Lang::tr{'copfilter smtp auth pass'}:&nbsp;<img src='/blob.gif' alt='*' /> </td>
        <td><input type='password' size="15" name='SMTP_AUTH_PASS' value='$copfiltersettings{'SMTP_AUTH_PASS'}' /> </td>
</tr>

<tr>
       <td>$Lang::tr{'copfilter upd_mail_notif'}:**&nbsp; </td>
       <td><select name='UPDATE_MAIL_NOTIF'>
            <option value='off' $selected{'UPDATE_MAIL_NOTIF'}{'off'}>off</option>
            <option value='on' $selected{'UPDATE_MAIL_NOTIF'}{'on'}>on</option></select></td>
       <td> </td>
       <td>$Lang::tr{'copfilter smtp auth sec'}:&nbsp; </td>
       <td><select name='SMTP_AUTH_SECURE'>
            <option value='off' $selected{'SMTP_AUTH_SECURE'}{'off'}>off</option>
            <option value='sslv3' $selected{'SMTP_AUTH_SECURE'}{'sslv3'}>SSL</option>
            <option value='tlsv1' $selected{'SMTP_AUTH_SECURE'}{'tlsv1'}>TLS</option> </select></td>
</tr>

<tr>
	<td>&nbsp;</td>
</tr>

<tr>
    <td colspan='5'> $Lang::tr{'copfilter email note'} </td>
</tr>

<tr>
    <td colspan='5'> $Lang::tr{'copfilter upd_mail_note'} </td>
</tr>

<tr>
        <td colspan='2'>$Lang::tr{'copfilter email restart'} </td>
	<td>&nbsp;</td>
</tr>
<tr>
        <td colspan='2'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter save_norestart'}' /> </td>
        <td colspan='3'>&nbsp; <img src='/blob.gif' align='top' alt='*' />&nbsp;<font>$Lang::tr{'this field may be blank'}</font></td>
</tr>

</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />";


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
