#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#



use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';



$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
&Header::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_testlog.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}





################################################################################
##   ACTIONs
################################################################################


######### Send Testvirus
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send testvirus'} )
{
        system ('/usr/local/bin/copfilter_sendtestvirus 2>&1 |logger -t "copfilter send testvirus" &');
        $copfiltersettings{'ACTION'} = '';
}


######### Send Testspam
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send testspam'} )
{
        system ('/usr/local/bin/copfilter_sendtestspam 2>&1 |logger -t "copfilter send testspam" &');
        $copfiltersettings{'ACTION'} = '';
}


######### Send Testattachment (exe)
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send exe attachment'} )
{
        system ('/usr/local/bin/copfilter_sendexeattachment 2>&1 |logger -t "copfilter send exe attachment" &');
        $copfiltersettings{'ACTION'} = '';
}


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{


################################################################################
##   Checking input values
################################################################################

	if  ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 


ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################




################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);


        }


$copfiltersettings{'ACTION'} = '';

}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    #print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    print "&nbsp;</class>\n";
    &Header::closebox();
}


################################################################################
##  Website - Test / Debug
################################################################################
print "<a name='test'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter testdebug'}:");
print "<form method='post' action='/cgi-bin/copfilter_testlog.cgi' enctype='multipart/form-data'>";
print <<END


<br /><u><b>$Lang::tr{'copfilter testpop3'}</b></u>

<table width='100%' border='0'>
<tr>
        <td width='30%'></td>
        <td width='20%'></td>
        <td width='2%'></td>
        <td width='48%'></td>
</tr>
<tr>
	<td colspan='2'>$Lang::tr{'copfilter testpop3-2'}</td>
	<td>&nbsp; &nbsp; &nbsp;  </td>
	<td valign='middle'><br /><input type='submit' name='ACTION' value='$Lang::tr{'copfilter send testvirus'}' />
    <br />&nbsp;
    <br />&nbsp;
	<br /><input type='submit' name='ACTION' value='$Lang::tr{'copfilter send testspam'}' />
    <br />&nbsp;
    <br />&nbsp;
	<br /><input type='submit' name='ACTION' value='$Lang::tr{'copfilter send exe attachment'}' />
    <br />&nbsp;
    <br />&nbsp;</td>
</tr>
</table>

<br />
<br />
<br /><u><b>$Lang::tr{'copfilter mailtestresult'}</b></u><br /><br />

$Lang::tr{'copfilter mailtestresult2'}
<pre>
X-Filtered-With: Copfilter Version 1.0.85.3 (P3Scan 2.3.2)
X-Copfilter-Virus-Scanned: ClamAV 0.97.1 / 53 / 12592 / 123 / 26960 - 2011-06-07 01:00
X-Copfilter-Virus-Scanned: AVG 7.5.52 - Engine 442 - Virus Database 270.14.151/3413 2011-01-31 00:41
X-Copfilter-Virus-Scanned: F-PROT 6.3.3.5015 - Engine 4.5.1.85 - Virus Database 2011-01-30 19:50
X-Copfilter-Browsing-Scanned: ClamAV using safebrowsing.cld - 2011-06-07 01:00
X-Copfilter-Scam-Scanned: ClamAV using scam.ndb - 2011-01-28 14:43
X-Copfilter-Scamlink-Scanned: ClamAV using scamnailer.ndb - 2011-01-31 00:40
X-Copfilter-Phishing-Scanned: ClamAV using phish.ndb - 2011-01-28 12:40
X-Copfilter-Spam-Scanned: ClamAV using spam.ldb - 2011-01-27 12:40
X-Copfilter-Spam-Attachment-Scanned: ClamAV using spamattach.hdb - 2011-01-27 12:40
X-Copfilter-SpamImage-Scanned: ClamAV using spamimg.hdb - 2011-01-27 12:40
X-Copfilter-Lottery-Scanned: ClamAV using lott.ndb - 2011-01-27 16:40
X-Copfilter-Spear-Scanned: ClamAV using spear.ndb - 2011-01-29 02:40
X-Copfilter-Spearlink-Scanned: ClamAV using spearl.ndb - 2011-01-29 03:43
X-Copfilter-Junk-Scanned: ClamAV using junk.ndb - 2011-01-28 12:40
X-Copfilter-Junk-URLBL-Scanned: ClamAV using jurlbl.ndb - 2011-01-31 00:40
X-Copfilter-Junk-URLBLA-Scanned: ClamAV using jurlbla.ndb - 2011-01-31 00:40
X-Copfilter-Rogue-Scanned: ClamAV using rogue.hdb - 2011-01-29 13:40
X-Copfilter-Winnow-Phishing-Scanned: ClamAV using wphsh.ndb - 2011-01-31 00:40
X-Copfilter-Winnow-Malware-Scanned: ClamAV using wmal.hdb - 2011-01-30 22:52
X-Copfilter-Winnow-Spam-Scanned: ClamAV using wspam.ndb - 2011-01-30 22:47
X-Copfilter-Winnow-Pattern-Scanned: ClamAV using wpatt.ldb - 2010-11-12 10:40
X-Copfilter-Winnow-Attachment-Scanned: ClamAV using wattach.hdb - 2011-01-30 22:55
X-Copfilter-MSRBL-SPAM-Scanned: ClamAV using MSRBL-SPAM.ndb - 2010-04-07 09:42
X-Copfilter-MSRBL-Images-Scanned: ClamAV using MSRBL-Images.hdb - 2010-04-21 12:40
X-Copfilter-CRDF-Scanned: ClamAV using crdfam.hdb - 2011-01-30 22:56
X-Copfilter-LW-Scam-Scanned: ClamAV using LW-Scam.ndb - 2011-01-27 13:40
X-Copfilter-LW-Image-Scanned: ClamAV using LW-Image.hdb - 2011-01-27 12:40
X-Copfilter-Batch-Scanned: ClamAV using secinfobat.hdb - 2010-06-29 12:01
X-Copfilter-SecuriteInfo-Scanned: ClamAV using securiteinfo.hdb - 2010-12-15 14:12
X-Copfilter-Honeynet-Scanned: ClamAV using honeynet.hdb - 2010-05-27 16:12
X-Copfilter-DOS-Scanned: ClamAV using secinfodos.hdb - 2010-05-27 16:12
X-Copfilter-ELF-Scanned: ClamAV using secinfoelf.hdb - 2010-05-27 16:12
X-Copfilter-HTML-Scanned: ClamAV using secinfohtm.hdb - 2010-09-23 19:49
X-Copfilter-Office-Scanned: ClamAV using secinfooff.hdb - 2010-06-29 11:53
X-Copfilter-PDF-Scanned: ClamAV using secinfopdf.hdb - 2010-11-16 16:42
X-Copfilter-Bash-Scanned: ClamAV using secinfosh.hdb - 2010-05-27 16:13
X-Copfilter-INetMsg-Spam-Scanned: ClamAV using inet.ndb - 2011-01-30 23:52
X-Copfilter-Malware-Scanned: ClamAV using mbl.ndb - 2011-01-31 00:10
</pre>
<br />
<br />
<table border='0'>
<tr>
    <td><br /><u><b>$Lang::tr{'copfilter testhttp&ftp'}</b></u><br /><br /></td>
    <td width='70'> </td>
    <td colspan='5' <br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;<u><b>$Lang::tr{'copfilter log'}</b></u><br /><br /></td>
</tr>
    <td valign='top'> <a> $Lang::tr{'copfilter testvirus http'}</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.com' target='_blank'>COM-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.zip' target='_blank'>ZIP-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar2.zip' target='_blank'>ZIP(2)-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar3.zip' target='_blank'>ZIP(3)-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar4.zip' target='_blank'>ZIP(4)-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.tar' target='_blank'>TAR-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.com.gz' target='_blank'>GZ-Datei</a>
     <br /><a href='http://meineipadresse.de/testvirus/eicar.cab' target='_blank'>CAB-Datei</a>
    <br /><a> $Lang::tr{'copfilter testvirus ftp'}</a>
     <br /><a href='ftp://ftp.kaspersky.com/utils/eicar/eicar.zip' target='_blank'>ZIP-Datei</a>
    <br /><a href='ftp://ftp.hogia.net/pub/jbdata/eicar.com' target='_blank'>COM-Datei</a></td>
    <td> &nbsp;  &nbsp;
    <td> &nbsp;  &nbsp;
    <td> &nbsp;  &nbsp;
    <td valign='top'>
          <a href='/copfilterlog/clamd.log' target='_blank'>clamd.log</a>
    <br /><a href='/copfilterlog/avgscan.log' target='_blank'>avgscan.log</a>
    <br /><a href='/copfilterlog/avg7upd.log' target='_blank'>avg7upd.log</a>
    <br /><a href='/copfilterlog/frox.log' target='_blank'>frox.log</a>
    <br /><a href='/copfilterlog/havp_access.log' target='_blank'>havp_access.log</a>
    <br /><a href='/copfilterlog/havp_error.log' target='_blank'>havp_error.log</a>
    <br /><a href='/copfilterlog/monit.log' target='_blank'>monit.log</a>
  </td>
  <td> &nbsp; &nbsp;
  </td>
  <td valign='top'>
          <a href='/copfilterlog/freshclam.log' target='_blank'>freshclam.log</a>
    <br /><a href='/copfilterlog/privoxy_logfile' target='_blank'>privoxy_logfile</a>
    <br /><a href='/copfilterlog/razor-agent.log' target='_blank'>razor-agent.log</a>
    <br /><a href='/copfilterlog/renattach.log' target='_blank'>renattach.log</a>
    <br /><a href='/copfilterlog/spamd.log' target='_blank'>spamd.log</a>
    <br /><a href='/copfilterlog/spey.log' target='_blank'>spey.log</a>
    <br /><a href='/copfilterlog/messages.log' target='_blank'>messages.log</a>
  </td>
  </td>
  <td> &nbsp;  &nbsp; 
  </td>
  <td valign='top'>
          <a href='/copfilterlog/crondaily.log' target='_blank'>crondaily.log</a>
    <br /><a href='/copfilterlog/cron4hourly.log' target='_blank'>cron4hourly.log</a>
    <br /><a href='/copfilterlog/cronhourly.log' target='_blank'>cronhourly.log</a>
    <br /><a href='/copfilterlog/3pmodify.log' target='_blank'>3pmodify.log</a>
    <br /><a href='/copfilterlog/httpd_access.log' target='_blank'>httpd_access.log</a>
    <br /><a href='/copfilterlog/httpd_error.log' target='_blank'>httpd_error.log</a>
    <br /><a href='/copfilterlog/p3scan.log' target='_blank'>p3scan.log</a>
    <br /><a href='/copfilterlog/proxsmtpd.log' target='_blank'>proxsmtpd.log</a>
  </td>
</tr>
</table>




<br />
<br />

<!--
<table border='0'>
<tr>
        <td><input type='submit' name='ACTION' value='Start p3scan debugging' /></td> 
        <td> &nbsp; &nbsp; <input type='submit' name='ACTION' value='$Lang::tr{'copfilter start proxsmtpd debug'}' /></td>
        <td> &nbsp; &nbsp; <input type='submit' name='ACTION' value='$Lang::tr{'copfilter make all tests'}' /> </td>
        <td> &nbsp; &nbsp; $Lang::tr{'copfilter make_test1'}</td>
        <td></td>
</tr>
</table>
<br />
<b>$Lang::tr{'copfilter make_test2'}</b>
-->

<br />



<table width='100%' border='1' cellpadding='5'>
<tr>
END
;

if ( $copfiltersettings{'RETRIEVE_LATEST_VERSION'} eq 'on' ) {

my $return = &downloadver();
my @latest2 = split(/;x;/,$return);
my @latest = split(/LATEST-VERSION-IS/,$latest2[1]);
$copfiltersettings{'LATESTVERSION'} = $latest[1];

#if ( $copfiltersettings{'LATESTVERSION'} == $copfiltersettings{'VERSION'} ) {
  print "<td width='25%' align='center'>$Lang::tr{'copfilter latestversion'}: \n";
  print "<font color='#339933'>";
  print "<b><br />";
  print $copfiltersettings{'LATESTVERSION'};
  print "</b>";
  print "</font>";
#}
#else
#{
#  print "<font color='#993333'>";
#  print $copfiltersettings{'LATESTVERSION'};
#  print "</font>";
#
#}
print <<END
	<br />$Lang::tr{'copfilter latestbetaversion'}: 
END
;
#my $return = &downloadver();
my @latestbeta = split(/LATEST-BETA-VERSION-IS/,$return);
$copfiltersettings{'LATESTBETAVERSION'} = $latestbeta[1];
# Get installed version
my $installedversion;
my @installedversion;

#if ( $copfiltersettings{'LATESTBETAVERSION'} == $copfiltersettings{'VERSION'} ) {
#  print "<font color='#339933'>";
  print "<font color='#993333'>";
  print "<b><br />";
  print $copfiltersettings{'LATESTBETAVERSION'};
  print "</b>";
  print "</font>";
#}
#else
#{
#  print "<font color='#993333'>";
#  print $copfiltersettings{'LATESTBETAVERSION'};
#  print "</font>";
#
#}

}

print <<END
<!--        <br /> $Lang::tr{'copfilter update green'}
        <br /> $Lang::tr{'copfilter update red'} -->
        </td>
        <td  width='30%' align='center'><b><font color='#000000'>$Lang::tr{'copfilter installedversion'}</font><br /><font color='#2229B5'>$copfiltersettings{'VERSION'}</font></b><br />$Lang::tr{'copfilter forum'}
            <a href='http://www.copfilter.org/forum' target='_blank'>http://www.copfilter.org/forum</a></td>
        <td width='25%' align='center'>$Lang::tr{'copfilter latestversion2'}
            <a href='http://www.copfilter.org' target='_blank'>http://www.copfilter.org</a> </td>
        <td width='20%' align='center'>$Lang::tr{'copfilter mailing list1'}<br />
                        <a href='http://lists.sourceforge.net/lists/listinfo/copfilter-main'  target='_blank'>$Lang::tr{'copfilter mailing list2'}</a>
                        <br /><a href='http://sourceforge.net/mailarchive/forum.php?forum_id=43901' target='_blank'>$Lang::tr{'copfilter mailing list3'}</a></td>
</tr>
</table>
END
;

print "</form>\n";

&Header::closebox();


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
