#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#

# Add entry in menu
# MENUENTRY copfilter 060 "HTTP Filter" "copfilter http"
#
# Make sure translation exists $Lang::tr{'copfilter http'}

use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';
my $sortorder = 2;
my $databases = '';
$copfiltersettings{'ACTION'} = '';

$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&General::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_http.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}





################################################################################
##   HTTP
################################################################################

######### PRIVOXY_ENABLE
$selected{'PRIVOXY_ENABLE'}{'off'} = '';
$selected{'PRIVOXY_ENABLE'}{'on'} = '';
$selected{'PRIVOXY_ENABLE'}{$copfiltersettings{'PRIVOXY_ENABLE'}} = "selected='selected'";

########## HTTP_SCAN_GREEN
#$selected{'HTTP_SCAN_GREEN'}{'off'} = '';
#$selected{'HTTP_SCAN_GREEN'}{'on'} = '';
#$selected{'HTTP_SCAN_GREEN'}{$copfiltersettings{'HTTP_SCAN_GREEN'}} = "selected='selected'";
#
########## HTTP_SCAN_ORANGE
#$selected{'HTTP_SCAN_ORANGE'}{'off'} = '';
#$selected{'HTTP_SCAN_ORANGE'}{'on'} = '';
#$selected{'HTTP_SCAN_ORANGE'}{$copfiltersettings{'HTTP_SCAN_ORANGE'}} = "selected='selected'";
#
########## HTTP_SCAN_BLUE
#$selected{'HTTP_SCAN_BLUE'}{'off'} = '';
#$selected{'HTTP_SCAN_BLUE'}{'on'} = '';
#$selected{'HTTP_SCAN_BLUE'}{$copfiltersettings{'HTTP_SCAN_BLUE'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN
$selected{'HTTP_VIRUS_SCAN'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN'}{$copfiltersettings{'HTTP_VIRUS_SCAN'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN_TRANSPARENT
$selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{$copfiltersettings{'HTTP_VIRUS_SCAN_TRANSPARENT'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN_CLAMAV
$selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN_CLAMAV'}{$copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'}} = "selected='selected'";

######### HTTP_CLAMAV_LIBRARY
$selected{'HTTP_CLAMAV_LIBRARY'}{'off'} = '';
$selected{'HTTP_CLAMAV_LIBRARY'}{'on'} = '';
$selected{'HTTP_CLAMAV_LIBRARY'}{$copfiltersettings{'HTTP_CLAMAV_LIBRARY'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN_FPROT
$selected{'HTTP_VIRUS_SCAN_FPROT'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN_FPROT'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN_FPROT'}{$copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'}} = "selected='selected'";


################################################################################
##   ACTIONs
################################################################################



######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################

	if ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_CLAMAV_LIBRARY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 


        if ( $copfiltersettings{'PRIVOXY_ENABLE'} eq 'on' && $copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'off')
        {
                $errormessage = $Lang::tr{'copfilter enable havp'};
                goto ERROR;
        }
      
        if ( $copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'on' && $copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'} eq 'off' && $copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'} eq 'off')
        {
                $errormessage = $Lang::tr{'copfilter http_all_off'};
                goto ERROR;
        }
      

ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }




################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/havp_enable";
	    unlink "${copfilter_swroot}/etc/privoxy_enable";
        if ( $copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'on' ) {
		    system ('/usr/bin/touch', "${copfilter_swroot}/etc/havp_enable"); }
	    if ($copfiltersettings{'PRIVOXY_ENABLE'} eq 'on') {
		    system ('/usr/bin/touch', "${copfilter_swroot}/etc/privoxy_enable"); }


# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
            system('/usr/local/bin/copfilter_restarthavp');
            print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";

            system('/usr/local/bin/copfilter_restartprivoxy');
            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log();
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "&nbsp;</class>\n";
    &Header::closebox();
}


################################################################################
##  Website - HTTP Scanning
################################################################################
print "<a name='http'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter http'} (HAVP,privoxy):");
print "<form method='post' action='/cgi-bin/copfilter_http.cgi' enctype='multipart/form-data'>";
print <<END

<!-- $Lang::tr{'copfilter http_web_proxy_enable'} -->
<table border='0' cellpadding='5'>

<tr>
	<!-- <td width='210'></td> -->
	<td width='210'></td>
	<td width='100'></td>
	<td width='50'></td>
	<td width='230'></td>
	<td>&nbsp;</td>
</tr>
<tr>
<!--        <td> $Lang::tr{'copfilter http_scan_green'}</td>
        <td> <select name='HTTP_SCAN_GREEN'>
             <option value='on' $selected{'HTTP_SCAN_GREEN'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_SCAN_GREEN'}{'off'}>off</option> </select></td>
-->
        <td> $Lang::tr{'copfilter http_virscan'}</td>
        <td> <select name='HTTP_VIRUS_SCAN'>
             <option value='on' $selected{'HTTP_VIRUS_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN'}{'off'}>off</option> </select></td>
	<td> &nbsp;</td>
        <td> $Lang::tr{'copfilter http_scan'}</td>
        <td> <select name='PRIVOXY_ENABLE'>
             <option value='on' $selected{'PRIVOXY_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'PRIVOXY_ENABLE'}{'off'}>off</option> </select></td>
        <!--
        <td> $Lang::tr{'copfilter http_virscan'}</td>
        <td> <select name='HTTP_VIRUS_SCAN'>
             <option value='on' $selected{'HTTP_VIRUS_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN'}{'off'}>off</option> </select></td>
        -->


</tr>
END
;

#<tr>
#END
#;
#if ($netsettings{'ORANGE_DEV'}) {
#print <<END
#        <td> $Lang::tr{'copfilter http_scan_orange'}</td>
#        <td> <select name='HTTP_SCAN_ORANGE'>
#             <option value='on' $selected{'HTTP_SCAN_ORANGE'}{'on'}>on</option>
#             <option value='off' $selected{'HTTP_SCAN_ORANGE'}{'off'}>off</option> </select></td>
#        <td> </td>
#END
#;
#}
#else {
#print <<END 
#        <td> </td>
#        <td> </td>
#END
#}
#print <<END
#	<td> </td>
#	<td> </td>
#	<td> </td>
#
#
#</tr>
#<tr>
#END
#;
#if ($netsettings{'BLUE_DEV'}) {
#print <<END
#        <td> $Lang::tr{'copfilter http_scan_blue'}</td>
#        <td> <select name='HTTP_SCAN_BLUE'>
#             <option value='on' $selected{'HTTP_SCAN_BLUE'}{'on'}>on</option>
#             <option value='off' $selected{'HTTP_SCAN_BLUE'}{'off'}>off</option> </select></td>
#END
#;
#}
#else {
#print "<td> </td>\n";
#print "<td> </td>\n";
#}
#print <<END
#	<td> </td>
#	<td> </td>
#</tr>

print <<END
<table border='0' cellpadding='5'>
<tr>
	<td width='210'></td>
	<td width='100'></td>
	<td width='50'></td>
	<td width='190'></td>
	<td></td>
</tr>
<tr>
        <td> $Lang::tr{'copfilter http_virscan_transparent'}</td>
        <td> <select name='HTTP_VIRUS_SCAN_TRANSPARENT'>
             <option value='on' $selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'off'}>off</option> </select></td>
	<td></td>
         <td valign='top' rowspan='1' colspan='4' > $Lang::tr{'copfilter http2'}
             <br /> 
             <br />
             <a href='http://config.privoxy.org'>privoxy configuration</a> &nbsp; &nbsp; &nbsp;
             <a href="javascript:void(window.open('http://config.privoxy.org/toggle?mini=y&amp;set=toggle','ijbstatus','width=250,height=100,resizable=yes,scrollbars=no,toolbar=no,location=no,directories=no,status=no,menubar=no,copyhistory=no').focus());"> privoxy bookmarklet</a>
         </td>
</tr>
<tr>
	<td> &nbsp;</td
</tr>

<tr>
	<td valign='top' colspan='4'> $Lang::tr{'copfilter http3'} </td>
</tr>
<tr>
        <td> $Lang::tr{'copfilter http_clamav'}</td>
        <td> <select name='HTTP_VIRUS_SCAN_CLAMAV'>
             <option value='on' $selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'off'}>off</option> </select></td>
	<td> &nbsp;</td
</tr>
<tr>
        <td> $Lang::tr{'copfilter http_clamav_library'}</td>
        <td> <select name='HTTP_CLAMAV_LIBRARY'>
             <option value='on' $selected{'HTTP_CLAMAV_LIBRARY'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_CLAMAV_LIBRARY'}{'off'}>off</option> </select>
END
;

if ($copfiltersettings{'HTTP_CLAMAV_LIBRARY'} eq 'on' ) {
$databases = `ls --ignore=*.c?d ${copfilter_swroot}/opt/havp/virdb/`;
if ( ! $databases eq '' ){
print <<END
<td colspan = '2'><b>$Lang::tr{'copfilter clamd thrdp_info7'}</b>$databases</td>
END
;

}

}
print <<END
</td>
	<td> &nbsp;</td>
</tr>
END
;

print <<END
<tr>
        <td> $Lang::tr{'copfilter havp_tmpfs'}</td>
        <td> <select name='HAVP_TMPFS'>
             <option value='on' $selected{'HAVP_TMPFS'}{'on'}>on</option>
             <option value='off' $selected{'HAVP_TMPFS'}{'off'}>off</option> </select></td>
	<td> &nbsp;</td>
</tr>
END
;

if ($copfiltersettings{'FPROT_INSTALLED'} eq 'yes' ) {

if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscand") {

print <<END
<tr>
        <td> $Lang::tr{'copfilter http_fprot'}</td>
        <td> <select name='HTTP_VIRUS_SCAN_FPROT'>
             <option value='on' $selected{'HTTP_VIRUS_SCAN_FPROT'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN_FPROT'}{'off'}>off</option> </select></td>
	<td> &nbsp;</td
</tr>
END
;
}

else {
print "<tr><td>$Lang::tr{'copfilter http_fprot_free_only'} </td/</tr>\n";
}

}

print <<END
<tr>
	<td> $Lang::tr{'copfilter havp_viruslog'}</td
</tr>

<tr>
	<td> &nbsp;</td
</tr>

<tr>
    <td colspan='5'> $Lang::tr{'copfilter http note'} </td>
</tr>

<tr>
    <td colspan='5'> 
        $Lang::tr{'copfilter http restart'}
    </td>
</tr>

</table>

<table>
<tr>
        <td colspan='3'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        </td>
</tr>

<tr>
        <td colspan='2'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td width='40'>&nbsp; </td>
        <!-- <td> $Lang::tr{'copfilter http4'}</td> -->
        <td> </td>
</tr>

<!-- can we get this working ? <a href="javascript:void(window.open('http://config.privoxy.org/toggle?mini=y&amp;set=enabled','ijbstatus','width=250,height=100,resizable=yes,scrollbars=no,toolbar=no,location=no,directories=no,status=no,menubar=no,copyhistory=no').focus());">Privoxy - Enable</a></li>
<a href="javascript:void(window.open('http://config.privoxy.org/toggle?mini=y&amp;set=disabled','ijbstatus','width=250,height=100,resizable=yes,scrollbars=no,toolbar=no,location=no,directories=no,status=no,menubar=no,copyhistory=no').focus());">Privoxy - Disable</a></li> --> 

</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
