#!/bin/bash
#
. /var/log/copfilter/default/etc/global_settings

if [ -f /tmp/modify.running ]; then
	echo "modify script is still running! Check your system!" | logger -t "copfilter modify 3rd-party-sigs"
	exit 1
fi


TDIR=/tmp/clamdatabases
CDIR=$BASEDIR/opt/clamav/virdb
BDIR=$BASEDIR/opt/clamav/dbbackup
HDIR=$BASEDIR/opt/havp/virdb
TMPFILE=/tmp/3pmodify.tmp
PRE="THRDP_"
### Sanesecurity-Start ###
declare -a SSFILES="THRDP_FILETYPE_ENABLE,filetype.ftm THRDP_MSRBL_IMAGES_ENABLE,MSRBL_Images.hdb THRDP_MSRBL_SPAM_ENABLE,MSRBL_SPAM.ndb THRDP_LW_IMAGE_ENABLE,LW_Image.hdb THRDP_LW_SCAM_ENABLE,LW_Scam.ndb \
THRDP_WSPAM_ENABLE,wspam.ndb THRDP_SPAMIMG_ENABLE,spamimg.hdb THRDP_SPAM_ENABLE,spam.ldb THRDP_LOTT_ENABLE,lott.ndb THRDP_SPEARL_ENABLE,spearl.ndb THRDP_SPEAR_ENABLE,spear.ndb \
THRDP_JUNK_ENABLE,junk.ndb THRDP_SCAM_ENABLE,scam.ndb THRDP_PHISH_ENABLE,phish.ndb THRDP_ROGUE_ENABLE,rogue.hdb THRDP_JURLBLA_ENABLE,jurlbla.ndb THRDP_JURLBL_ENABLE,jurlbl.ndb \
THRDP_WPHSH_ENABLE,wphsh.ndb THRDP_WMAL_ENABLE,wmal.hdb THRDP_WPATT_ENABLE,wpatt.ldb THRDP_WATTACH_ENABLE,wattach.hdb \
THRDP_INET_ENABLE,inet.ndb THRDP_SCAMNAILER_ENABLE,scamnailer.ndb THRDP_CRDFAM_ENABLE,crdfam.hdb THRDP_SPAMATTACH_ENABLE,spamattach.hdb THRDP_BOFCRACK_ENABLE,bofcrack.ndb \
THRDP_BOFMAL_ENABLE,bofmal.ndb THRDP_BOFPHSH_ENABLE,bofphsh.ndb"
declare -i SSDEL=0
declare -i SSDELH=0
declare -i SSADD=0
declare -i SSADDH=0
SSFILCADD=""
SSFILCDEL=""
SSFILHADD=""
SSFILHDEL=""
### Sanesecurity-End ###

### SecuriteInfo-Start ###
declare -a SIFILES="THRDP_SECURITEINFO_ENABLE,securiteinfo.hdb THRDP_HONEYNET_ENABLE,honeynet.hdb THRDP_SECINFOBAT_ENABLE,secinfobat.hdb THRDP_SECINFODOS_ENABLE,secinfodos.hdb \
THRDP_SECINFOELF_ENABLE,secinfoelf.hdb THRDP_SECINFOHTM_ENABLE,secinfohtm.hdb THRDP_SECINFOOFF_ENABLE,secinfooff.hdb THRDP_SECINFOPDF_ENABLE,secinfopdf.hdb THRDP_SECINFOSH_ENABLE,secinfosh.hdb"
declare -i SIDEL=0
declare -i SIDELH=0
declare -i SIADD=0
declare -i SIADDH=0
SIFILCADD=""
SIFILHADD=""
SIFILCDEL=""
SIFILHDEL=""
### SecuriteInfo-End ###

### MalwarePatrol-Start ###
declare -a MPFILES="THRDP_MBL_ENABLE,mbl.ndb"
declare -i MPDEL=0
declare -i MPDELH=0
declare -i MPADD=0
declare -i MPADDH=0
MPFILCADD=""
MPFILHADD=""
MPFILCDEL=""
MPFILHDEL=""
### MalwarePatrol-End ###

if [ -e /var/ipcop/red/active ]; then
	touch /tmp/modify.running
	if [ ! -f /tmp/3pmodify.tmp ]; then
		touch /tmp/3pmodify.tmp
	fi


	if [ "x$SSFILES" != "x" ]; then
		for SSENTRY in $SSFILES; do
			SIGVALUE=`echo $SSENTRY | cut -d "," -f1`
			SIGFILE=`echo $SSENTRY | cut -d "," -f2`
			SIGVALUE=`grep -E "^$SIGVALUE" $BASEDIR/etc/global_settings | cut -d "=" -f2`
			if [ "x$SIGVALUE" = "xoff" ]; then
				if [ -f $TDIR/$SIGFILE ]; then
					rm -f $TDIR/$SIGFILE
				fi
				if [ -f $CDIR/$SIGFILE ]; then
					rm -f $CDIR/$SIGFILE
					SSDEL=SSDEL+1
					if [ "x$SSFILCDEL" = "x" ]; then
						SSFILCDEL=$SIGFILE
					else
						SSFILCDEL="$SSFILCDEL, $SIGFILE"
					fi
				fi
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
				fi
				if [ -f $BDIR/$SIGFILE ]; then
					rm -f $BDIR/$SIGFILE
				fi
			fi
			if [ "x$SIGVALUE" = "xon" ]; then
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
					SSDELH=SSDELH+1
					if [ "x$SSFILHDEL" = "x" ]; then
						SSFILHDEL=$SIGFILE
					else
						SSFILHDEL="$SSFILHDEL, $SIGFILE"
					fi
				fi
			fi
			if [ "x$HTTP_CLAMAV_LIBRARY" = "xoff" ]; then
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
					SSDELH=SSDELH+1
					if [ "x$SSFILHDEL" = "x" ]; then
						SSFILHDEL=$SIGFILE
					else
						SSFILHDEL="$SSFILHDEL, $SIGFILE"
					fi
				fi
			fi
			if [ "x$SIGVALUE" = "xon" -o "x$SIGVALUE" = "xhavp" ]; then
				if [ ! -f $CDIR/$SIGFILE ]; then
					if [ "x$SIGVALUE" = "xon" ]; then
						SSADD=SSADD+1
						if [ "x$SSFILCADD" = "x" ]; then
							SSFILCADD=$SIGFILE
						else
							SSFILCADD="$SSFILCADD, $SIGFILE"
						fi
					elif [ "x$SIGVALUE" = "xhavp" -a "x$HTTP_CLAMAV_LIBRARY" = "xoff" ]; then
						SSADD=SSADD+1
						if [ "x$SSFILCADD" = "x" ]; then
							SSFILCADD=$SIGFILE
						else
							SSFILCADD="$SSFILCADD, $SIGFILE"
						fi
					fi
				fi
				if [ ! -f $HDIR/$SIGFILE -a "x$HTTP_CLAMAV_LIBRARY" = "xon" ]; then
					if [ "x$SIGVALUE" = "xhavp" ];then
						SSADDH=SSADDH+1
						if [ "x$SSFILHADD" = "x" ]; then
							SSFILHADD=$SIGFILE
						else
							SSFILHADD="$SSFILHADD, $SIGFILE"
						fi
					
					fi
				fi
			fi
		done
	fi

	if [ "x$SIFILES" != "x" ]; then
		for SIENTRY in $SIFILES; do
			SIGVALUE=`echo $SIENTRY | cut -d "," -f1`
			SIGFILE=`echo $SIENTRY | cut -d "," -f2`
			SIGVALUE=`grep -E "^$SIGVALUE" $BASEDIR/etc/global_settings | cut -d "=" -f2`
			if [ "x$SIGVALUE" = "xoff" ]; then
				if [ -f $TDIR/$SIGFILE ]; then
					rm -f $TDIR/$SIGFILE
				fi
				if [ -f $CDIR/$SIGFILE ]; then
					rm -f $CDIR/$SIGFILE
					SIDEL=SIDEL+1	
					if [ "x$SIFILCDEL" = "x" ]; then
						SIFILCDEL=$SIGFILE
					else
						SIFILCDEL="$SIFILCDEL, $SIGFILE"
					fi
				fi
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
				fi
				if [ -f $BDIR/$SIGFILE ]; then
					rm -f $BDIR/$SIGFILE
				fi
			fi
			if [ "x$SIGVALUE" = "xon" ]; then
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
					SIDELH=SIDELH+1
					if [ "x$SIFILHDEL" = "x" ]; then
						SIFILHDEL=$SIGFILE
					else
						SIFILHDEL="$SIFILHDEL, $SIGFILE"
					fi
				fi
			fi
			if [ "x$HTTP_CLAMAV_LIBRARY" = "xoff" ]; then
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
					SIDELH=SIDELH+1
					if [ "x$SIFILHDEL" = "x" ]; then
						SIFILHDEL=$SIGFILE
					else
						SIFILHDEL="$SIFILHDEL, $SIGFILE"
					fi
				fi
			fi
			if [ "x$SIGVALUE" = "xon" -o "x$SIGVALUE" = "xhavp" ]; then
				if [ ! -f $CDIR/$SIGFILE ]; then
					if [ "x$SIGVALUE" = "xon" ]; then
						SIADD=SIADD+1
						if [ "x$SIFILCADD" = "x" ]; then
							SIFILCADD=$SIGFILE
						else
							SIFILCADD="$SIFILCADD, $SIGFILE"
						fi
					elif [ "x$SIGVALUE" = "xhavp" -a "x$HTTP_CLAMAV_LIBRARY" = "xoff" ]; then
						SIADD=SIADD+1
						if [ "x$SIFILCADD" = "x" ]; then
							SIFILCADD=$SIGFILE
						else
							SIFILCADD="$SIFILCADD, $SIGFILE"
						fi
					fi
				fi
				if [ ! -f $HDIR/$SIGFILE -a "x$HTTP_CLAMAV_LIBRARY" = "xon" ]; then
					if [ "x$SIGVALUE" = "xhavp" ]; then
						SIADDH=SIADDH+1
						if [ "x$SIFILHADD" = "x" ]; then
							SIFILHADD=$SIGFILE
						else
							SIFILHADD="$SIFILHADD, $SIGFILE"
						fi
					
					fi
				fi
			fi

		done
	fi
	if [ "x$MPFILES" != "x" ]; then
		for MPENTRY in $MPFILES; do
			SIGVALUE=`echo $MPENTRY | cut -d "," -f1`
			SIGFILE=`echo $MPENTRY | cut -d "," -f2`
			SIGVALUE=`grep -E "^$SIGVALUE" $BASEDIR/etc/global_settings | cut -d "=" -f2`
			if [ "x$SIGVALUE" = "xoff" ]; then
				if [ -f $TDIR/$SIGFILE ]; then
					rm -f $TDIR/$SIGFILE
				fi
				if [ -f $CDIR/$SIGFILE ]; then
					rm -f $CDIR/$SIGFILE
					MPDEL=MPDEL+1	
					if [ "x$MPFILCDEL" = "x" ]; then
						MPFILCDEL=$SIGFILE
					else
						MPFILCDEL="$MPFILCDEL, $SIGFILE"
					fi
				fi
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
				fi
				if [ -f $BDIR/$SIGFILE ]; then
					rm -f $BDIR/$SIGFILE
				fi
			fi
			if [ "x$SIGVALUE" = "xon" ]; then
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
					MPDELH=MPDELH+1
					if [ "x$MPFILHDEL" = "x" ]; then
						MPFILHDEL=$SIGFILE
					else
						MPFILHDEL="$MPFILHDEL, $SIGFILE"
					fi
				fi
			fi
			if [ "x$HTTP_CLAMAV_LIBRARY" = "xoff" ]; then
				if [ -f $HDIR/$SIGFILE ]; then
					rm -f $HDIR/$SIGFILE
					MPDELH=MPDELH+1
					if [ "x$MPFILHDEL" = "x" ]; then
						MPFILHDEL=$SIGFILE
					else
						MPFILHDEL="$MPFILHDEL, $SIGFILE"
					fi
				fi
			fi
			if [ "x$SIGVALUE" = "xon" -o "x$SIGVALUE" = "xhavp" ]; then
				if [ ! -f $CDIR/$SIGFILE ]; then
					if [ "x$SIGVALUE" = "xon" ]; then
						MPADD=MPADD+1
						if [ "x$MPFILCADD" = "x" ]; then
							MPFILCADD=$SIGFILE
						else
							MPFILCADD="$MPFILCADD, $SIGFILE"
						fi
					elif [ "x$SIGVALUE" = "xhavp" -a "x$HTTP_CLAMAV_LIBRARY" = "xoff" ]; then
						MPADD=MPADD+1
						if [ "x$MPFILCADD" = "x" ]; then
							MPFILCADD=$SIGFILE
						else
							MPFILCADD="$MPFILCADD, $SIGFILE"
						fi
					fi
				fi
				if [ ! -f $HDIR/$SIGFILE -a "x$HTTP_CLAMAV_LIBRARY" = "xon" ]; then
					if [ "x$SIGVALUE" = "xhavp" ];then
						MPADDH=MPADDH+1
						if [ "x$MPFILHADD" = "x" ]; then
							MPFILHADD=$SIGFILE
						else
							MPFILHADD="$MPFILHADD, $SIGFILE"
						fi
					
					fi
				fi
			fi

		done
	fi

	if [ $SSDEL != 0 -o $SIDEL != 0 -o $MPDEL != 0 ]; then
		echo ""
		echo "deleted for use with clamd and havp library scanner:"
		if [ $SSDEL != 0 ]; then
			echo "$SSDEL Sanesecurity databases: $SSFILCDEL"
		fi
		if [ $SIDEL != 0 ]; then
			echo "$SIDEL SecuriteInfo databases: $SIFILCDEL"
		fi
		if [ $MPDEL != 0 ]; then
			echo "$MPDEL MalwarePatrol databases: $MPFILCDEL"
		fi
	fi
	if [ $SSDELH != 0 -o $SIDELH != 0 -o $MPDELH != 0 ]; then
		echo ""
		echo "deleted for use with havp library scanner only:"
		if [ $SSDELH != 0 ]; then
			echo "$SSDELH Sanesecurity databases: $SSFILHDEL"
		fi
		if [ $SIDELH != 0 ]; then
			echo "$SIDELH SecuriteInfo databases: $SIFILHDEL"
		fi
		if [ $MPDELH != 0 ]; then
			echo "$MPDELH MalwarePatrol databases: $MPFILHDEL"
		fi
	fi
	##### Updates Start ####
	if [ $SSADD != 0 -o $SSADDH != 0 ]; then
		if [ ! -f /tmp/cron.sa.tmp ]; then
			touch /tmp/cron.sa.tmp
		fi
		$BASEDIR/opt/tools/bin/cron.hourly >> /tmp/cron.sa.tmp 2>&1
	fi
	if [ $SIADD != 0 -o $SIADDH != 0 ]; then
		if [ ! -f /tmp/cron.si.tmp ]; then
			touch /tmp/cron.si.tmp
		fi
		$BASEDIR/opt/tools/bin/cron.daily "no" >> /tmp/cron.si.tmp 2>&1
	fi
	if [ $MPADD != 0 -o $MPADDH != 0 ]; then
		if [ ! -f /tmp/cron.mb.tmp ]; then
			touch /tmp/cron.mb.tmp
		fi
		$BASEDIR/opt/tools/bin/cron.4hourly >> /tmp/cron.mb.tmp 2>&1
	fi
	#### Updates Ende ####
	if [ $SSADDH != 0 -o $SIADDH != 0 -o $MPADDH != 0 ]; then
		echo ""
		echo "added for new use with clamd and havp library scanner:"
		if [ $SSADDH != 0 ]; then
			echo "$SSADDH Sanesecurity databases: $SSFILHADD"
		fi
		if [ $SIADDH != 0 ]; then
			echo "$SIADDH SecuriteInfo databases: $SIFILHADD"
		fi
		if [ $MPADDH != 0 ]; then
			echo "$MPADDH MalwarePatrol databases: $MPFILHADD"
		fi
		echo ""
	fi
	if [ $SSADD != 0 -o $SIADD != 0 -o $MPADD != 0 ]; then
		echo ""
		echo "added for new use with clamd only:"
		if [ $SSADD != 0 -a $SSADDH == 0 ]; then
			echo "$SSADD Sanesecurity databases: $SSFILCADD"
		fi
		if [ $SIADD != 0 -a $SIADDH == 0 ]; then
			echo "$SIADD SecuriteInfo databases: $SIFILCADD"
		fi
		if [ $MPADD != 0 -a $MPADDH == 0 ]; then
			echo "$MPADD MalwarePatrol databases: $MPFILCADD"
		fi
		echo ""
	fi

	if [ $SSADD != 0 -o $SIADD != 0 -o $MPADD != 0 -o $SSADDH != 0 -o $SIADDH != 0 -o $MPADDH != 0 -o $SSDEL != 0 -o $SIDEL != 0 -o $MPDEL != 0 -o $SSDELH != 0 -o $SIDELH != 0 -o $MPDELH != 0 ]; then
		echo ""
		echo `date +[%Z]" "%F" "%T`
		echo ""
		echo "_______________________________________________________________________________________________________________________________"
	fi
	cat $TMPFILE >> $BASEDIR/opt/tools/var/log/3pmodify.log
	rm -f $TMPFILE
else
	echo "no internet connection available, so no modified 3rd party signature updates will be downloaded"
	echo ""
	echo `date +[%Z]" "%F" "%T`
	echo ""
	echo "_______________________________________________________________________________________________________________________________"

	cat $TMPFILE >> $BASEDIR/opt/tools/var/log/3pmodify.log
	rm -f $TMPFILE
fi
rm -f /tmp/modify.running
exit 0
